##
## Self-Organizing Map Program Package
##
##    makefile for UNIX with SysV or GNU make utility
##
##    copy this file to the name makefile before executing the make command
##    if you are using GNU gmake, change the definition of $(STRANGE)
##
## version 1.0 October 1992
#*                                                                      *
#*  NOTE: This program package is copyrighted in the sense that it      *
#*  may be used for scientific purposes. The package as a whole, or     *
#*  parts thereof, cannot be included or used in any commercial         *
#*  application without written permission granted by its producents.   *
#*  No programs contained in this package may be copied for commercial  *
#*  distribution.                                                       *
#*                                                                      *
#*  All comments concerning this program package may be sent to the     *
#*  e-mail address 'lvq@cochlea.hut.fi'.                                *
#*                                                                      *

## platform specific definitions:

SHELL = /bin/csh
CC = cc
CFLAGS = -O
LDFLAGS =
LDLIBS = -lm
GRAPHICSLIBS = -lgl_s

# the following is used with SysV make utility
STRANGE = $$@.c

# the following is used with GNU implementation of make (gmake)
#STRANGE = %: %.c

###

NONGRAPHICTARGETS = vsom randinit lininit visual vcal qerror sammon vfind

GRAPHICTARGETS = gvisual

TARGETS = $(NONGRAPHICTARGETS) $(GRAPHICTARGETS)

ROUTINES = lvq_pak.o som_rout.o

HEADERS = lvq_pak.h

all : $(NONGRAPHICTARGETS) graphics

.c.o : ; $(CC) $(CFLAGS) -c $*.c

.c : ; $(CC) $(CFLAGS) $(LDFLAGS) $@.c $(ROUTINES) $(LDLIBS) -o $@

$(ROUTINES) : $(HEADERS) makefile

$(TARGETS) : $(STRANGE) $(ROUTINES)
	$(CC) $(CFLAGS) $(LDFLAGS) $@.c $(ROUTINES) $(LDLIBS) -o $@

graphics: 
	@-if ( -x /bin/4d && { /bin/4d } && \
               ! { $(MAKE) -q $(GRAPHICTARGETS) } ) \
	$(MAKE) LDLIBS="$(GRAPHICSLIBS) $(LDLIBS)" $(GRAPHICTARGETS)

example :
	./randinit -din ex.dat -cout ex.cod -xdim 12 -ydim 8 -topol hexa \
  -neigh bubble -rand 1
	./vsom     -din ex.dat -cin ex.cod  -cout ex.cod -rlen 1000 \
  -alpha 0.05 -radius 10 -rand 1
	./vsom     -din ex.dat -cin ex.cod  -cout ex.cod -rlen 10000 \
  -alpha 0.02 -radius 3 -rand 1
	./qerror   -din     ex.dat -cin ex.cod
	./vcal     -din ex_fts.dat -cin ex.cod -cout ex.cod
	./visual   -din ex_ndy.dat -cin ex.cod -dout ex.nvs
	./visual   -din ex_fdy.dat -cin ex.cod -dout ex.fvs

